#ifndef BININPUTSTREAM_H_INCLUDED
#define BININPUTSTREAM_H_INCLUDED

class BinInputStream : public wxInputStream
{
public:
    // ctor associates the stream with the given string which makes a copy of
    // it
    BinInputStream(const char * c, int len);
    virtual ~BinInputStream();

    virtual wxFileOffset GetLength() const;

protected:
    virtual wxFileOffset OnSysSeek(wxFileOffset ofs, wxSeekMode mode);
    virtual wxFileOffset OnSysTell() const;
    virtual size_t OnSysRead(void *buffer, size_t size);

private:
    // the buffer we're reading from
    const char* m_buf;

    // length of the buffer we're reading from
    size_t m_len;

    // position in the stream in bytes, *not* in chars
    size_t m_pos;

    DECLARE_NO_COPY_CLASS(BinInputStream)
};

#endif // BININPUTSTREAM_H_INCLUDED
