class CNCFile;

#ifndef CNCFILE_H
#define CNCFILE_H
#include <wx/docview.h>
#include "App.h"
#include "MyFrame.h"

class CNCFile: public wxDocument
{
private:
	int headsize;
	char head[53];
protected:
	void ReadHead(int size, const char * d);
	void WriteHead(FILE * fp);
	void WriteFooter(FILE * fp);
	void SetFileEnde(char * bin, int len);
	wxString comment;
public:

	enum
	{
		ID_TB_SAVE 			= 1,
		ID_TB_SAVE_AS_PDF 	= 2,
		ID_TB_SETTINGS 		= 4,
		ID_TB_CUT 			= 8,
		ID_TB_COPY 			= 16,
		ID_TB_PASTE 		= 32,
		ID_TB_SEARCH 		= 64,
		ID_TB_UNDO 			= 128,
		ID_TB_REDO 			= 256
	};

	CNCFile();
	~CNCFile();
	virtual int getIconID() = 0;
	//Toolbarfunktionen alle klein geschrieben
	virtual void copy();
	virtual void paste();
	virtual void cut();
	virtual void undo();
	virtual void redo();
	virtual void search();
	virtual void save_as_pdf();

	virtual bool OpenFile(wxInputStream & in, const wxString & filename) = 0;

	virtual int GetActiveToolbars();
	virtual void TextChanged() { Modify(true); }
	void ActualizeToolbar() { GetMainFrame()->ActualizeToolbar(); }

	bool OnOpenDocument(const wxString& filename);

	virtual void Modify(bool mod);

	void SetComment(wxString & comment) { this->comment = comment; }
	const wxString & GetComment() { return comment; }
	void SelectAll();
	void OnFileOpened();

};

#endif //CNCFILE_H
