#include "Project.h"
#include "MyDocManager.h"
#include "ProjectView.h"

using namespace std;

IMPLEMENT_DYNAMIC_CLASS(Project, wxDocument)

int ComparePrjFiles(PrjFiles *item1, PrjFiles *item2)
{
	if(item1->m_name < item2->m_name)
		return -1;
	else if(item1->m_name == item2->m_name)
		return 0;
	return 1;
}

Project::Project()
{
	static int new_id = 0;
	cout << "Project created (ID = " << ++new_id << ")\n";
	id=new_id;

	wxString tmp;

/*
	for(int i = 0; i < 20; i++)
	{
		tmp = "testdatei ";
		tmp << id;
		AddFile(new PrjFile(tmp, id%2, NULL, 0));
	}*/

}

bool Project::OnSaveDocument(const wxString& filename)
{
	cout << "Save Project as " << filename << "\n";
	return true;
}

void Project::Clear()
{
	m_list.clear();
}

bool Project::OnOpenDocument(const wxString& filename)
{
	FILE * fp;
	int c;
	int i=0;
	int x, n;
	int anz_daten;
	int start_daten;
	int pos;
	int size;
	char typ;
	char * tmpdata;
	int akpos;

	char buffer[512];


	wxString tmpstr;

	//Aufrumen
	this->Clear();

	fp=fopen(filename.c_str(), "rb");
	if(!fp)
	{
		return false;
	}

	//Version einlesen und kontrollieren
	do
	{
		c=fgetc(fp);
		buffer[i++]=c;
	}
	while(c!=0 && !feof(fp));

	if(strcmp("cnprj_v100", buffer)!=0)
	{
		wxMessageBox("Dies ist keine lesbare Projektdatei", "Dateiformat", wxICON_ERROR);
		return false;
	}

	//Name einlesen
	tmpstr = "";
	i=0;
	do
	{
		c=fgetc(fp);
		tmpstr << c;
	}
	while(c!=0 && !feof(fp));

	//TODO:Projektname != Dateiname

	fread(&anz_daten, 1, sizeof(int), fp);
	fread(&start_daten, 1, sizeof(int), fp);


	for(i=0; i < anz_daten; i++)
	{
		tmpstr="";
		for(x=0; x < 11; x++)
			tmpstr << (char)fgetc(fp);

		tmpstr.Remove(tmpstr.Find(" "));

		typ = fgetc(fp);
		fread(&pos, 1, sizeof(int), fp);
		fread(&size, 1, sizeof(int), fp);

		tmpdata = new char[size];

		akpos = ftell(fp);

		if(fseek(fp, pos+start_daten, SEEK_SET)!=0)
		{
			wxMessageBox("Dateiposition konnte nicht gefunden werden!", "Interner Fehler", wxICON_ERROR);
			return false;
		}
		for(n=0; n < size; n++)
			tmpdata[n]=fgetc(fp);

		fseek(fp, akpos, SEEK_SET);

		cout << "Projektdatei:" << tmpstr << "\n";

		AddFile(new PrjFile(tmpstr, typ, tmpdata, size));

		if(feof(fp))
		{
			wxMessageBox("Projektdatei ist unvollstndig!", "Fehler", wxICON_ERROR);
			return false;
		}
	}

	fclose(fp);

	((ProjectView *)GetFirstView())->Refresh();

	GetFirstView()->OnChangeFilename();

	return true;
}

void Project::AddFile(PrjFile * file)
{
	m_list[id++]=file;
}

PrjFile * Project::getfile(int id)
{
	return m_list[id];
}

void Project::DeleteFile(int id)
{
	m_list.erase(id);
}

void Project::Open(int id)
{
	PrjFile * tmp = m_list[id];
	if(tmp)
		((MyDocManager *)GetDocumentManager())->Open(tmp, id);
}

PrjFilesArray & Project::GetProgramms()
{
	return Get(true);
}

PrjFilesArray & Project::GetUProgramms()
{
	return Get(false);
}

PrjFilesArray & Project::Get(bool programm)
{
	PrjFilesArray * arr = new PrjFilesArray(ComparePrjFiles);

	ProjectFileHash::iterator it;
    for(it = m_list.begin(); it != m_list.end(); ++it)
    {
    	if((it->second->GetTyp()==1)==programm)
			arr->Add(new PrjFiles(it->second->GetName(), it->first));
    }

    return *arr;
}

