#ifndef PROJECT_H_INCLUDED
#define PROJECT_H_INCLUDED

#include <wx/docview.h>
#include "PrjFile.h"
#include <wx/hashmap.h>

/*
Aufbau der Datei:
	Version;Name;Anzahl Dateien; beginn Datenbereich

	Dateiname;Typ;position;grsse
	(position relativ zu datenbereich)
	\0 -> Datenbereich

*/
class Project;

WX_DEFINE_SORTED_ARRAY(PrjFiles *, PrjFilesArray);
WX_DECLARE_HASH_MAP(int, PrjFile*, wxIntegerHash, wxIntegerEqual, ProjectFileHash);


class Project : public wxDocument
{
public:
	Project();
	bool OnSaveDocument(const wxString& filename);
	bool OnOpenDocument(const wxString& filename);

	void AddFile(PrjFile * file);
	PrjFile * getfile(int id);
	void DeleteFile(int id);
	void Open(int id);
	PrjFilesArray & GetProgramms();
	PrjFilesArray & GetUProgramms();

private:
	DECLARE_DYNAMIC_CLASS(Project)
	ProjectFileHash m_list;
	PrjFilesArray & Get(bool programm);
	void Clear();
	int id;
};

#endif // PROJECT_H_INCLUDED
