#include "ProjectView.h"
#include "App.h"
#include "MyFrame.h"

using namespace std;

IMPLEMENT_DYNAMIC_CLASS(ProjectView, wxView)


ProjectView::ProjectView() : m_tree(*GetMainFrame()->m_tree)
{
	cout << "ProjectView created\n";
}

bool ProjectView::OnCreate(wxDocument* doc, long flags)
{
	cout << "ProjectView::OnCreate called\n";

	this->doc = (Project *)doc;
	m_prjRoot = m_tree.AppendItem(GetMainFrame()->m_prjRoot, "Projekt", 5);

	Refresh();
	//Projektview sollte NIE aktiv sein!
	doc->GetDocumentManager()->ActivateView(this, false);
	return true;
}

void ProjectView::Refresh()
{
	wxTreeItemId programm;
	wxTreeItemId uprogramm;

	//Alte Eintrge lschen
	m_tree.DeleteChildren(m_prjRoot);
	m_view_list.clear();

	programm = m_tree.AppendItem(m_prjRoot, "Programme", 3, 2);
	AppendTree(programm, doc->GetProgramms(), 6);
	uprogramm = m_tree.AppendItem(m_prjRoot, "Unterprogramme", 3, 2);
	AppendTree(uprogramm, doc->GetUProgramms(), 7);

	GetMainFrame()->m_tree->Refresh();
}

void ProjectView::AppendTree(wxTreeItemId root, PrjFilesArray & files, int icon)
{
	for(unsigned int i=0; i < files.GetCount(); i++)
		m_view_list[(int)m_tree.AppendItem(root, files.Item(i)->m_name, icon).m_pItem]=files.Item(i)->m_id;

	//Aufrumen
	//TODO:Beim speicher freigeben absturtz
	//WX_CLEAR_ARRAY(files);
}

void ProjectView::OnChangeFilename()
{
    wxString name;
    doc->GetPrintableName(name);
	m_tree.SetItemText(m_prjRoot, name);
	GetMainFrame()->m_tree->Refresh();
}

bool ProjectView::DblClick(wxTreeItemId item)
{
	if(m_view_list[(int)item.m_pItem]==0)
		return false;
	((Project *)GetDocument())->Open(m_view_list[(int)item.m_pItem]);
	return false;
}

















