#include "TextEditView.h"
#include "App.h"
#include "MyFrame.h"
#include "Images.h"
#include "CNCFile.h"

using namespace std;

IMPLEMENT_DYNAMIC_CLASS(TextEditView, wxView)

TextEditView::~TextEditView()
{
	if(textsw)
		delete textsw;
}

bool TextEditView::OnCreate(wxDocument *doc, long WXUNUSED(flags) )
{
	std::cout << "TextEditView Created!\n";
	textsw = new MyTextWindow(doc->GetDocumentManager(), this, GetMainFrame()->nb, MyFrame::ID_TextEditWindow, wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE);

	GetMainFrame()->nb->AddPage(textsw, wxT("<neu>")); //wird sowiso berschrieben
	GetMainFrame()->nb->SetPageBitmap(GetMainFrame()->nb->GetPageIndex(textsw), *Image::Get(((CNCFile *)doc)->getIconID()));

	this->doc=doc;
	OnUpdate(NULL, NULL);
	return true;
}

// Handled by wxTextWindow
void TextEditView::OnDraw(wxDC *WXUNUSED(dc) )
{
}

void TextEditView::OnUpdate(wxView *WXUNUSED(sender), wxObject *WXUNUSED(hint) )
{
}

void TextEditView::OnChangeFilename()
{
	RefreshTitle();
 	//Dateiliste im Tree aktualisieren
	GetMainFrame()->RefreshOpenFileList();
}

void TextEditView::RefreshTitle()
{
   wxString name;
    doc->GetPrintableName(name);
	GetMainFrame()->nb->SetPageText(GetMainFrame()->nb->GetPageIndex(textsw),
		name + ((doc->IsModified())? "*" : ""));
}

bool TextEditView::OnClose(bool deleteWindow)
{

	cout << "TextEditView::OnClose(" << ((deleteWindow) ? "true" : "false") << ") called\n";

	if (!GetDocument()->Close())
		return false;
/*
	//Darf hier noch nicht geloescht werden, es darf nur der Tab geschlossen werden...
	if(deleteWindow && textsw)
	{
		delete textsw;
		textsw=NULL;
	}
*/
	return true;
}

