#include "TextWindow.h"
#include "TextEditView.h"
#include "MyDocManager.h"

/*

MyTextWindow::MyTextWindow(wxView *v, wxWindow *frame, int id, const wxPoint& pos, const wxSize& size, long style):
 wxTextCtrl(frame, id, _T(""), pos, size, style)
{
  view = v;
}

MyTextWindow::~MyTextWindow()
{
	//Pointer auf sich selbst NULLen
	((TextEditView *)view)->textsw=NULL;
}


*/



MyTextWindow::MyTextWindow(wxDocManager * docmanager, wxView *v, wxWindow *frame, int id, const wxPoint& pos, const wxSize& size, long style):
	wxScintilla(frame, id, pos, size, style)
{
	view = v;
/*
	int linemgn, symmgn, fldmgn;//these store the number for the left margins
	int linew, symw, fldw;

	linemgn = 0;
	symmgn = 1;
	fldmgn = 2;
	linew = 30;
	symw = 15;
	fldw = 15;
	SetMargins(3,2);
	SetMarginWidth(linemgn,30);
	SetMarginWidth(symmgn,16);
	SetMarginSensitive(1,true);
	SetMarginMask(symmgn, ~wxSCI_MASK_FOLDERS);
	SetMarginWidth(fldmgn,0);
	SetMarginSensitive(fldmgn,true);

	SetMarginMask(fldmgn, wxSCI_MASK_FOLDERS);
	*/

	StyleSetFaceName(wxSCI_STYLE_DEFAULT, wxString("Courier New"));

	SetMarginWidth(0, 30); // turn on the linenumbers margin, set width to 30pixels
	SetMarginWidth(1, 0);  // turn off the folding margin
	SetMarginType(0, 1);   // set margin type to linenumbers

	SetViewWhiteSpace(((MyDocManager *)docmanager)->GetShowControlCharacter());

	SetCaretLineBackground(wxColour(0xFF,0xFF,0x00));
	SetCaretLineVisible(true);

	SetFoldMarginColour(true, wxColour(0xFF,0xFF,0xFF));
	SetFoldMarginHiColour(true, wxColour(0xFF,0xFF,0xFF));

//	SetFoldMarginColour(true, wxColour(0xFF,0xFF,0xFF));
//	SetFoldMarginHiColour(true, wxColour(0xFF,0xFF,0xFF));

	SetWhitespaceForeground(true, wxColour(0x00,0x00,0x00));
	SetWhitespaceBackground(true, wxColour(0xFF,0xFF,0xFF));
	SetCaretForeground(wxColour(0x00,0x00,0x00));
	SetSelBackground(true, wxColour(0xCE,0xFF,0x84));
	SetSelForeground(true, wxColour(0x00,0x00,0x00));

//	StyleSetSpec(wxSCI_STYLE_COMMENT, wxT("fore:#898989,back:#FFFFFF"));

/*
	StyleSetSpec(XSTC_DEF(WS_INVISIBLE),          wxT("fore:#000000,back:#FFFFFF"));
	StyleSetSpec(XSTC_DEF(WS_VISIBLEALWAYS),      wxT("fore:#000000,back:#FFFFFF"));
	StyleSetSpec(XSTC_DEF(WS_VISIBLEAFTERINDENT), wxT("fore:#000000,back:#FFFFFF"));
	StyleSetSpec(XSTC_DEF(EOL_CRLF),              wxT("fore:#000000,back:#FFFFFF"));
	StyleSetSpec(XSTC_DEF(EOL_CR),                wxT("fore:#000000,back:#FFFFFF"));
	StyleSetSpec(XSTC_DEF(EOL_LF),                wxT("fore:#000000,back:#FFFFFF"));

	StyleSetSpec(XSTC_DEF(CP_DBCS),         wxT("fore:#000000,back:#FFFFFF"));
	StyleSetSpec(XSTC_DEF(MARKER_MAX),      wxT("fore:#000000,back:#FFFFFF"));
	StyleSetSpec(XSTC_DEF(MARK_CIRCLE),     wxT("fore:#000000,back:#FFFFFF"));
	StyleSetSpec(XSTC_DEF(MARK_ROUNDRECT),  wxT("fore:#000000,back:#FFFFFF"));
	StyleSetSpec(XSTC_DEF(MARK_ARROW),      wxT("fore:#000000,back:#FFFFFF"));
	StyleSetSpec(XSTC_DEF(MARK_SMALLRECT),  wxT("fore:#000000,back:#FFFFFF"));
	StyleSetSpec(XSTC_DEF(MARK_SHORTARROW), wxT("fore:#000000,back:#FFFFFF"));
	StyleSetSpec(XSTC_DEF(MARK_EMPTY),      wxT("fore:#000000,back:#FFFFFF"));
	StyleSetSpec(XSTC_DEF(MARK_ARROWDOWN),  wxT("fore:#000000,back:#FFFFFF"));
	StyleSetSpec(XSTC_DEF(MARK_MINUS),      wxT("fore:#000000,back:#FFFFFF"));
	StyleSetSpec(XSTC_DEF(MARK_PLUS),       wxT("fore:#000000,back:#FFFFFF"));


	StyleSetSpec(XSTC_DEF(MARK_BACKGROUND), wxT("fore:#000000,back:#FFFFFF"));
	StyleSetSpec(XSTC_DEF(MARK_DOTDOTDOT),  wxT("fore:#000000,back:#FFFFFF"));
	StyleSetSpec(XSTC_DEF(MARK_ARROWS),     wxT("fore:#000000,back:#FFFFFF"));
	StyleSetSpec(XSTC_DEF(MARK_PIXMAP),     wxT("fore:#000000,back:#FFFFFF"));
	StyleSetSpec(XSTC_DEF(MARK_ROUNDRECT),  wxT("fore:#000000,back:#FFFFFF"));
	StyleSetSpec(XSTC_DEF(MARK_CHARACTER),  wxT("fore:#000000,back:#FFFFFF"));

	StyleSetSpec(XSTC_DEF(STYLE_DEFAULT),        wxT("fore:#000000,back:#FFFFFF"));
	StyleSetSpec(XSTC_DEF(STYLE_LINENUMBER),     wxT("fore:#FFFFFF,back:#808080"));
	StyleSetSpec(XSTC_DEF(STYLE_BRACELIGHT),     wxT("fore:#388CD5,back:#FFFFFF"));
	StyleSetSpec(XSTC_DEF(STYLE_BRACEBAD),       wxT("fore:#F8B163,back:#FFFFFF"));
	StyleSetSpec(XSTC_DEF(STYLE_CONTROLCHAR),    wxT("fore:#000000,back:#FFFFFF"));
	StyleSetSpec(XSTC_DEF(STYLE_INDENTGUIDE),    wxT("fore:#000000,back:#FFFFFF"));
	StyleSetSpec(XSTC_DEF(STYLE_LASTPREDEFINED), wxT("fore:#000000,back:#FFFFFF"));
	StyleSetSpec(XSTC_DEF(STYLE_MAX),            wxT("fore:#000000,back:#FFFFFF"));


	colorstyle   = wxT("jeff");
	brkptcol     = wxT("#800000");
	actbrkptcol  = wxT("#0000FF");
	errorcol     = wxT("#080000");

	SetEdgeColour(edgcolr);
	SetEdgeColumn(edgcolm);
	SetEdgeMode(edgmod);
	SetWrapMode(wrapmod);
	SetWrapVisualFlags(wrapvf);
	SetLayoutCache(cachemod);
	SetCaretLineVisible(caretlv);

	XS_comment = wxT("fore:#008000,back:#FFFFFF");
	XS_comment2 = wxT("fore:#00CC00,back:#FFFFFF");
	XS_comment3 = wxT("fore:#808080,back:#FFFFFF");
	XS_s_string = wxT("fore:#000000,back:#FFFFDC");
	XS_d_string = wxT("fore:#000000,back:#FFFFDC");
	XS_number = wxT("fore:#813A00,back:#E6FFFF");
	XS_char = wxT("fore:#C2C5F8,back:#FFFFDC");
	XS_default = wxT("fore:#800000,back:#FFFFFF");
	XS_key1 = wxT("fore:#000080,back:#FFFFFF");
	XS_key2 = wxT("fore:#A65300,back:#FFFFFF");
	XS_key3 = wxT("fore:#A6718C,back:#FFFFFF");
	XS_key4 = wxT("fore:#388CE5,back:#FFFFFF");
	XS_preproc = wxT("fore:#008000,italic,back:#FFFFFF");
	XS_symbol = wxT("fore:#000000,back:#FFFFFF");
	XS_tag = wxT("fore:#808080,back:#FFFFFF");
	XS_user = wxT("fore:#CCCCCC,back:#FFFFFF");
	XS_misic = wxT("fore:#008000,bold,back:#FFFFFF");
	XS_lang = wxT("fore:#AA0063,back:#FFFFFF");
	XS_global = wxT("fore:#00FF00,back:#FFFFFF");
	XS_bad = wxT("fore:#CEFF84,back:#800000"); //illegal, error
	XS_instruction = wxT("fore:#FFFFDC,back:#FFFFFF"); //whatever
	XS_dtype = wxT("fore:#E6FFFF,back:#FFFFFF"); //datatype
*/




















}

MyTextWindow::~MyTextWindow()
{
	//Pointer auf sich selbst NULLen
	((TextEditView *)view)->textsw=NULL;
}

const wxString MyTextWindow::GetValue()
{
	return GetText();
}

void MyTextWindow::SetValue(const wxString&  value)
{
	SetText(value);
}

