#include <stdio.h>
#include <stdlib.h>
#include <string.h>
struct files
{
	char typ;
	char name[12];
	unsigned char groesse;
	unsigned char adressen[16];
};


struct files daten[256];
int datenanz=0;
void readfile(FILE * fp);
int getadress(int index, int * addr1, int * addr2, int * addr3, int * addr4);


int main(int argc, char** argv)
{
	FILE * fp, * fp2;
	int start=0;
	int i, ch;
	char verbose=0;
	char filename[512]="image.bin";
	if(argc>1)
	{
		strncpy(filename, argv[1], 512);
	}
	if(argc > 2 && argv[2][0]=='-' && argv[2][1]=='v' && argv[2][2]==0)
	{
		verbose=1;
	}
	fp=fopen(filename, "rb");
	if(!fp)
	{
		printf("Konnte %s nicht oeffnen!\n", filename);
		system("pause");
		exit(1);
	}
	//fp2=fopen("out.txt", "w");

	printf("===================================\n");
	fseek(fp, start, SEEK_SET);
	
	while(!feof(fp) && ftell(fp) < 0xb400)
	{
		ch=getc(fp);
		daten[datenanz].typ=ch;
		if(ch == 1 || ch == 2)
		{
			for(i=0; i < 11; i++)
			{
				ch=fgetc(fp);
				//fputc(ch, fp2);
				printf("%c", ch);
				daten[datenanz].name[i]=ch;
			}
			daten[datenanz].name[12]=0;

			//fputc('\t', fp2);
			printf(" ");
			for(i=0; i < 20; i++)
			{
				ch=fgetc(fp);
				//fprintf(fp2, "%02x", ch);
				printf("%02x", ch);
				if(i==3)
					daten[datenanz].groesse=(unsigned char)ch;
				if(i > 3)
				{
					daten[datenanz].adressen[i-4]=ch;
				}	
			}
			//fputc('\n', fp2);
			printf(" %i Byte", daten[datenanz].groesse*128);
			printf("\n");
			datenanz++;
		}
		else
		{
			for(i=0; i < 31; i++)
				ch=fgetc(fp);					
		}
	}
	printf("===================================\n");
	if(verbose)
		system("pause");
	system("mkdir 01");
	system("mkdir 02");
	readfile(fp);
	
	fclose(fp);
	//fclose(fp2);
	
	if(verbose)
		system("pause");
	
    return 0;
}

void writesektor(int leseptr, FILE * in, FILE * out, int size)
{
	int i;
	fseek(in, leseptr, SEEK_SET);
	for(i=0; i < size; i++)
		fputc(fgetc(in), out);
}

int getadress(int index, int * addr1, int * addr2, int * addr3, int * addr4)
{
	FILE * fp;
	char buffer[512];
	
	fp=fopen("index.csv", "r");
	if(!fp)
	{
		printf("index.csv konnte nicht geoffnet werden!\n");
		system("pause");
		exit(1);
	}
	
	while(fgets(buffer, 512, fp))
	{
		if(atoi(buffer)==index)
		{
			strtok(buffer, ";\n");
			*addr1=atoi(strtok(NULL, ";\n"));
			*addr2=atoi(strtok(NULL, ";\n"));
			*addr3=atoi(strtok(NULL, ";\n"));
			*addr4=atoi(strtok(NULL, ";\n"));
			fclose(fp);
			return 1;
		}
	}
	fclose(fp);
	return 0;
}

void readfile(FILE * fp)
{
	
	FILE * fpout;
	int i;
	int x;
	char filename[512];
	int a1, a2, a3, a4;
	char adress_ok;
	
	
	for(i=0; i < datenanz; i++)
	{
		strtok(daten[i].name, " ");
		sprintf(filename, "%02i\\%s.txt", daten[i].typ, daten[i].name);
		printf("%s, Dateigroesse: %iByte, Datei %i von %i \n", filename, daten[i].groesse*128, i +1, datenanz);
		printf("  Adressen:");
		adress_ok=1;
		//fr jede Adresse
		for(x=0; x < 16; x+=2)
			if(daten[i].adressen[x]!=0)
			{
				printf(" %i", daten[i].adressen[x]);
				if(!getadress(daten[i].adressen[x], &a1, &a2, &a3, &a4))
				{
					printf("!");
					adress_ok=0;
				}
			}
			else
			{
				printf("\n");
				break;
			}
		if(adress_ok)
		{
			fpout=fopen(filename, "wb");
			if(!fpout)
			{
				printf("%s.txt konnte nicht geoeffnet werden!\n", daten[i].name);
				system("pause");
				exit(1);
			}
			//fr jede Adresse
			for(x=0; x < 16 && daten[i].adressen[x]!=0; x+=2)
			{
				if(getadress(daten[i].adressen[x], &a1, &a2, &a3, &a4))
				{
					//1. Sektor
					if(x*2048+512 <= daten[i].groesse*128)
						writesektor(a1, fp, fpout, 512);
					else
						writesektor(a1, fp, fpout, daten[i].groesse*128-x*2048);
						
					//2. Sektor
					if(x*2048+1024 <= daten[i].groesse*128)
						writesektor(a2, fp, fpout, 512);
					else
						writesektor(a2, fp, fpout, daten[i].groesse*128-x*2048-512);
						
					//3. Sektor
					if(x*2048+1536 <= daten[i].groesse*128)
						writesektor(a3, fp, fpout, 512);
					else
						writesektor(a3, fp, fpout, daten[i].groesse*128-x*2048-1024);
						
					//4. Sektor
					if(x*2048+2048 <= daten[i].groesse*128)
						writesektor(a4, fp, fpout, 512);
					else
						writesektor(a4, fp, fpout, daten[i].groesse*128-x*2048-1536);
					
				}
				else
				{
					printf("Fehler! Die Datei \"index.csv\" wurde waerend dem Betrieb veraendert!\n");
					system("pause");
					exit(1);
				}
			}
			fclose(fpout);
		}
		else
		{
			printf("  Datei kann nicht gelesen werden, da nicht alle Adressen bekannt sind!\n");
		}
		printf("----\n");
	}
}











